2 # vim:shiftwidth=4:softtabstop=4:tabstop=4:
4 # client failure does not affect other clients
6 # Start load on clients (each client works on it's own directory).
7 # At defined (5-10 minutes) interval fail one random client and then fail mds.
8 # Reintegrate failed client after recovery completed,
9 # application errors are allowed for that client but not on other clients.
10 # 10 minute intervals and verify that no application errors occur.
12 # Test runs one of CLIENT_LOAD progs on remote clients.
17 # bug number for skipped test:
18 ALWAYS_EXCEPT="$RECOVERY_RANDOM_SCALE_EXCEPT"
19 # UPDATE THE COMMENT ABOVE WITH BUG NUMBERS WHEN CHANGING ALWAYS_EXCEPT!
21 LUSTRE=${LUSTRE:-$(cd $(dirname $0)/..; echo $PWD)}
22 . $LUSTRE/tests/test-framework.sh
24 . ${CONFIG:=$LUSTRE/tests/cfg/$NAME.sh}
27 remote_mds_nodsh && skip_env "remote MDS with nodsh" && exit 0
28 remote_ost_nodsh && skip_env "remote OST with nodsh" && exit 0
30 [ -z "$CLIENTS" -o $CLIENTCOUNT -lt 3 ] &&
31 skip_env "need three or more clients" && exit 0
33 if [ -z "$SHARED_DIRECTORY" ] || ! check_shared_dir $SHARED_DIRECTORY; then
34 skip_env "SHARED_DIRECTORY should be specified with a shared directory \
35 which is accessable on all of the nodes"
39 [[ $FAILURE_MODE = SOFT ]] && \
40 log "WARNING: $0 is not functional with FAILURE_MODE = SOFT, bz22797"
42 # Application failures are allowed for the failed client
43 # but not for other clients.
46 if [ "$SLOW" = "no" ]; then
47 DURATION=${DURATION:-$((60 * 30))}
49 DURATION=${DURATION:-$((60 * 60 * 24))}
51 SERVER_FAILOVER_PERIOD=${SERVER_FAILOVER_PERIOD:-$((60 * 10))} # 10 minutes
53 MINSLEEP=${MINSLEEP:-120}
54 REQFAIL_PERCENT=${REQFAIL_PERCENT:-3} # bug17839 comment 62
55 # round up the result of integer division: C=(A + (B - 1)) / B
56 REQFAIL=${REQFAIL:-$(((DURATION * REQFAIL_PERCENT + (SERVER_FAILOVER_PERIOD *
57 100 - 1 )) / SERVER_FAILOVER_PERIOD / 100))}
59 END_RUN_FILE=${END_RUN_FILE:-$SHARED_DIRECTORY/end_run_file}
60 LOAD_PID_FILE=${LOAD_PID_FILE:-$TMP/client-load.pid}
61 VMSTAT_PID_FILE=${VMSTAT_PID_FILE:-$TMP/vmstat.pid}
67 for facet in $MDTS ${FAILED_CLIENTS//,/ }; do
71 echo "$facet failed over $val times"
76 summary_and_cleanup () {
80 # Having not empty END_RUN_FILE means the failed loads only
81 if [ -s $END_RUN_FILE ]; then
82 print_end_run_file $END_RUN_FILE
86 echo $(date +'%F %H:%M:%S') Terminating clients loads ...
87 echo "$0" >> $END_RUN_FILE
89 [ $rc -eq 0 ] || result=FAIL
91 log "Duration: $DURATION
92 Server failover period: $SERVER_FAILOVER_PERIOD seconds
93 Exited after: $ELAPSED seconds
94 Number of failovers before exit:
96 Status: $result: rc=$rc"
98 # stop vmstat on OSS nodes
99 [ "$VMSTAT" ] && stop_process $(comma_list $(osts_nodes)) $VMSTAT_PID_FILE
101 # stop the client loads
102 stop_client_loads $NODES_TO_USE $LOAD_PID_FILE
104 if [ $rc -ne 0 ]; then
105 # we are interested in only on failed clients and servers
106 local failedclients=$(cat $END_RUN_FILE | grep -v $0)
107 gather_logs $(comma_list $(all_server_nodes) $failedclients)
113 ################################## Main Flow ###################################
116 check_and_setup_lustre
117 rm -rf $DIR/[Rdfs][0-9]*
119 MAX_RECOV_TIME=$(max_recovery_time)
121 # The test node needs to be insulated from a lustre failure as much as possible,
122 # so not even loading the lustre modules is ideal.
124 # -- remove hostname from clients list
125 zconf_umount $HOSTNAME $MOUNT
126 NODES_TO_USE=${NODES_TO_USE:-$CLIENTS}
127 NODES_TO_USE=$(exclude_items_from_list $NODES_TO_USE $HOSTNAME)
129 check_progs_installed $NODES_TO_USE ${CLIENT_LOADS[@]}
131 MDTS=$(get_facets MDS)
133 # Fail a random client and then failover a random MDS.
134 test_fail_client_mds() {
140 trap summary_and_cleanup EXIT INT
142 # start vmstat on OSS nodes
143 [ "$VMSTAT" ] && start_vmstat $(comma_list $(osts_nodes)) $VMSTAT_PID_FILE
147 start_client_loads $NODES_TO_USE
149 echo client loads pids:
150 do_nodesv $NODES_TO_USE "cat $LOAD_PID_FILE" || exit 3
156 local start_ts=$(date +%s)
157 local current_ts=$start_ts
159 while [ $ELAPSED -lt $DURATION -a ! -e $END_RUN_FILE ]; do
160 # In order to perform the
161 # expected number of failovers, we need to account the following:
162 # 1) the time that has elapsed during the client load checking
163 # 2) time takes for failover
164 it_time_start=$(date +%s)
166 fail_client=$(get_random_entry $NODES_TO_USE)
167 client_var=$(node_var_name $fail_client)_nums
169 # store the list of failed clients
170 # lists are comma separated
171 FAILED_CLIENTS=$(expand_list $FAILED_CLIENTS $fail_client)
173 serverfacet=$(get_random_entry $MDTS)
174 var=${serverfacet}_nums
176 # Check that our client loads are still running. If any have died,
177 # that means they have died outside of recovery, which is unacceptable.
178 log "==== Checking the clients loads BEFORE failover -- failure NOT OK \
179 ELAPSED=$ELAPSED DURATION=$DURATION PERIOD=$SERVER_FAILOVER_PERIOD"
180 check_client_loads $NODES_TO_USE || exit 4
182 log "FAIL CLIENT $fail_client..."
183 shutdown_client $fail_client
185 log "Starting failover on $serverfacet"
186 facet_failover "$serverfacet" || exit 1
188 if ! wait_recovery_complete $serverfacet; then
189 echo "$serverfacet recovery is not completed!"
193 boot_node $fail_client
194 echo "Reintegrating $fail_client"
195 zconf_mount $fail_client $MOUNT || exit $?
196 client_up $fail_client || exit $?
198 # Increment the number of failovers
201 val=$((${!client_var} + 1))
202 eval $client_var=$val
204 # load script on failed clients could create END_RUN_FILE
205 # We shuold remove it and ignore the failure if this
206 # file contains the failed client only.
207 # We can not use ERRORS_OK when start all loads at the start of
208 # this script because the application errors allowed for random
209 # failed client only, but not for all clients.
210 if [ -e $END_RUN_FILE ]; then
212 read end_run_node < $END_RUN_FILE
213 [[ $end_run_node = $fail_client ]] &&
214 rm -f $END_RUN_FILE || exit 13
217 restart_client_loads $fail_client $ERRORS_OK || exit $?
219 # Check that not failed clients loads are still running.
220 # No application failures should occur on clients that were not failed.
221 log "==== Checking the clients loads AFTER failed client reintegrated \
223 if ! ERRORS_OK= check_client_loads \
224 $(exclude_items_from_list $NODES_TO_USE $fail_client); then
225 log "Client load failed. Exiting..."
229 current_ts=$(date +%s)
230 ELAPSED=$((current_ts - start_ts))
231 sleep=$((SERVER_FAILOVER_PERIOD - (current_ts - it_time_start)))
233 # Keep counting the number of iterations when
234 # time spent to failover and two client loads check exceeded
235 # the value ( SERVER_FAILOVER_PERIOD - MINSLEEP ).
236 if [ $sleep -lt $MINSLEEP ]; then
237 reqfail=$((reqfail + 1))
238 log "WARNING: failover, client reintegration and \
239 check_client_loads time exceeded SERVER_FAILOVER_PERIOD - MINSLEEP!
240 Failed to load the filesystem with I/O for a minimum period of \
241 $MINSLEEP $reqfail times ( REQFAIL=$REQFAIL ).
242 This iteration, the load was only applied for sleep=$sleep seconds.
243 Estimated max recovery time : $MAX_RECOV_TIME
244 Probably the hardware is taking excessively long time to boot.
245 Try to increase SERVER_FAILOVER_PERIOD (current is $SERVER_FAILOVER_PERIOD), \
247 [ $reqfail -gt $REQFAIL ] && exit 6
250 log "Number of failovers:
251 $(numfailovers) and counting..."
253 [ $((ELAPSED + sleep)) -ge $DURATION ] && break
255 if [ $sleep -gt 0 ]; then
256 echo "sleeping $sleep seconds... "
262 run_test fail_client_mds "fail client, then failover MDS"
264 zconf_mount $HOSTNAME $MOUNT || error "mount $MOUNT on $HOSTNAME failed"
265 client_up || error "start client on $HOSTNAME failed"
268 check_and_cleanup_lustre